## mingw-w64-fluidsynth-2.4.8-2.src.tar.zst

=== test-android/app/src/main/cpp/CMakeLists.txt ===
# For more information about using CMake with Android Studio, read the
# documentation: https://d.android.com/studio/projects/add-native-code.html

# Sets the minimum version of CMake required to build the native library.

cmake_minimum_required(VERSION 3.10.2)

# Declares and names the project.

project("fluidsynth_tests")

set (TEST_SRC_DIR ../../../../../test)

# Creates and names a library, sets it as either STATIC
# or SHARED, and provides the relative paths to its source code.
# You can define multiple libraries, and CMake builds them for you.
# Gradle automatically packages shared libraries with your APK.

AUX_SOURCE_DIRECTORY(tests TEST_SRC_FILES)
FILE(GLOB LINKED_OBJ_FILES ../../../../../build_${CMAKE_ANDROID_ARCH_ABI}/src/CMakeFiles/libfluidsynth-OBJ.dir/**/*.o)

message("-----------------------TEST_SRC_FILES---------------------------")
message("${TEST_SRC_FILES}")
message("-----------------------LINKED_OBJ_FILES---------------------------")
message("${LINKED_OBJ_FILES}")

add_library( # Sets the name of the library.
             native-lib

             # Sets the library as a shared library.
             SHARED

             # Provides a relative path to your source file(s).
             ${LINKED_OBJ_FILES}

        tests/test_preset_pinning.c
        tests/test_seq_event_queue_remove.c
        tests/test_seq_scale.c
        tests/test_jack_obtaining_synth.c
        tests/test_settings_unregister_callback.c
        tests/test_pointer_alignment.c
        tests/test_sfont_zone.c
        tests/test_utf8_open.c
        tests/test_seqbind_unregister.c
        tests/test_sf3_sfont_loading.c
        tests/test_sample_cache.c
        tests/test_synth_process.c
        tests/test_ct2hz.c
        tests/test_seq_evt_order.c
        tests/test_snprintf.c
        tests/test_seq_event_queue_sort.c
        tests/test_sfont_loading.c
        tests/test_preset_sample_loading.c
        tests/test_sfont_unloading.c
        tests/test_sample_rate_change.c
        tests/test_sample_validate.c
        tests/test_synth_chorus_reverb.c
        tests/test_bug_635.c

             run_all_tests.c
             native-lib.cpp
        )

target_include_directories(native-lib
        PRIVATE
        ../../../../../build_${CMAKE_ANDROID_ARCH_ABI}
        ../../../../build-scripts/build-artifacts/include
        ../../../../build-scripts/android-build-root/${CMAKE_ANDROID_ARCH_ABI}/opt/android/include
        ../../../../build-scripts/android-build-root/${CMAKE_ANDROID_ARCH_ABI}/opt/android/include/glib-2.0
        ../../../../build-scripts/android-build-root/${CMAKE_ANDROID_ARCH_ABI}/opt/android/lib/glib-2.0/include
        ../../../../../src
        ../../../../../src/bindings
        ../../../../../src/drivers
        ../../../../../src/midi
        ../../../../../src/rvoice
        ../../../../../src/sfloader
        ../../../../../src/synth
        ../../../../../src/utils
        ../../../../../test
        )

# Searches for a specified prebuilt library and stores the path as a
# variable. Because CMake includes system libraries in the search path by
# default, you only need to specify the name of the public NDK library
# you want to add. CMake verifies that the library exists before
# completing its build.

find_library( # Sets the name of the path variable.
              log-lib

              # Specifies the name of the NDK library that
              # you want CMake to locate.
              log )


# Specifies libraries CMake should link to your target library. You
# can link multiple libraries, such as libraries you define in this
# build script, prebuilt third-party libraries, or system libraries.

target_link_directories(native-lib
        PRIVATE
        ../jniLibs/${CMAKE_ANDROID_ARCH_ABI})

target_link_libraries(native-lib
        ${log-lib}
        c++_shared
        gobject-2.0
        glib-2.0
        sndfile
        instpatch-1.0
        OpenSLES
        oboe
        )

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=fluidsynth
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.4.8
pkgrel=2
pkgdesc="A real-time software synthesizer based on the SoundFont 2 specifications (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.fluidsynth.org/"
msys2_repository_url='https://github.com/FluidSynth/fluidsynth'
msys2_references=(
  "cpe: cpe:/a:fluidsynth:fluidsynth"
)
license=('spdx:LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-libsndfile"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-portaudio"
         "${MINGW_PACKAGE_PREFIX}-readline"
          $([[ "${CARCH}" == "i686" ]] || echo "${MINGW_PACKAGE_PREFIX}-sdl3"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ladspa-sdk"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=("https://github.com/FluidSynth/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "010-no-undefined.patch")
sha256sums=('d6d04e9014557906ee42aa1fe3cd580840ea482d4c3b1a45fddd45ec606d6e97'
            '3f405ae883bbd123425848b5f74b19a3ec8d093dae33355a6aa02f0aed5c4714')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
    tar -xf "${_realname}-${pkgver}.tar.gz" || true

    cd "${_realname}-${pkgver}"
    patch -p1 -i "${srcdir}"/010-no-undefined.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  local -a _static_flags=(
    -DGIO_STATIC_COMPILATION
    -DGLIB_STATIC_COMPILATION
    -DGMODULE_STATIC_COMPILATION
    -DGOBJECT_STATIC_COMPILATION
  )

  mkdir -p "${srcdir}"/build-${MSYSTEM}-static && cd "${srcdir}"/build-${MSYSTEM}-static

  CFLAGS+=" ${_static_flags[@]}" \
  CXXFLAGS+=" ${_static_flags[@]}" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -Denable-portaudio=ON \
      -Denable-dbus=OFF \
      ../${_realname}-${pkgver}

  cmake --build ./

  mkdir -p "${srcdir}"/build-${MSYSTEM}-shared && cd "${srcdir}"/build-${MSYSTEM}-shared

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -G'Ninja' \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -Denable-portaudio=ON \
      -Denable-dbus=OFF \
      ../${_realname}-${pkgver}

  cmake --build ./
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}-static
  DESTDIR="${pkgdir}" cmake --install ./

  cd "${srcdir}"/build-${MSYSTEM}-shared
  DESTDIR="${pkgdir}" cmake --install ./

  local MINGW_PREFIX_WIN=$(cygpath -am ${MINGW_PREFIX})
  find "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig" -type f -name '*.pc' \
    -exec sed -i -e "s|${MINGW_PREFIX_WIN}|${MINGW_PREFIX}|g" \
    -e "s|${MINGW_PREFIX}/include|\${prefix}/include|g" \
    -e "s|${MINGW_PREFIX}/lib|\${prefix}/lib|g" {} \;

  install -vDm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
